// NuGet Packages required
// Microsoft.WindowsAPICodePack-Shell 

using Microsoft.WindowsAPICodePack.Dialogs;
using static System.Windows.Forms.VisualStyles.VisualStyleElement.Window;
using System.IO;
using System.Security.Cryptography;
using System.Text;
using System.Xml.Linq;
using System.Windows.Shapes;
using Path = System.IO.Path;
using System;

namespace xml_app_test
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            CommonOpenFileDialog dialog = new CommonOpenFileDialog();
            dialog.RestoreDirectory = true;
            dialog.IsFolderPicker = true;
            if (dialog.ShowDialog() == CommonFileDialogResult.Ok)
            {
                txtDirectorySource.Text = dialog.FileName;
            }
        }

        private void btnFileSaveAs_Click(object sender, EventArgs e)
        {
            SaveFileDialog filedialog = new SaveFileDialog();
            filedialog.Filter = "XML Dats (*.xml)|xml";
            filedialog.RestoreDirectory = true;

            if (filedialog.ShowDialog() == DialogResult.OK)
            {
                txtFileSave.Text = filedialog.FileName;
            }
        }

        private void btnGenerateXML_Click(object sender, EventArgs e)
        {

            string oldbrand = "";
            string newbrand = "";
            string oldsystem = "";
            string newsystem = "";
            string category = "";

            // Parse directory
            string[] files = Directory.GetFiles(txtDirectorySource.Text, "*.*", SearchOption.AllDirectories);
            foreach (string file in files)
            {
                string filename = Path.GetFileName(file);
                string filenamewithoutext = Path.GetFileNameWithoutExtension(file);
                string extension = Path.GetExtension(file);
                string[] subDirectories = file.Split("\\");

                string md5 = GetMD5HashFromFile(file);
                string sha1 = GetSHA1HashFromFile(file);

                // Get file length
                long length = new FileInfo(file).Length;

                newbrand  = subDirectories[0];
                newsystem = subDirectories[1];
                category  = subDirectories[2];

                if (oldbrand != newbrand || oldbrand == "")
                {
                    if (oldbrand != "")
                    {
                        // Close old XML
                    }

                    oldbrand = newbrand;
                    // make new XML

                }

                if (oldsystem != newsystem || newsystem == "")
                {
                    oldsystem = newsystem;   
                }



            // start new xml doc for each new 1st lvl folder
            /*    new XDeclaration("1.0", "utf-8", "yes"),
                new XComment("XML from plain code"),

                new XElement("datafile",
                    new XElement("header",
                        new XElement("name", ""),
                        new XElement("description", ""),
                        new XElement("version", ""),
                        new XElement("author", ""),
                        new XElement("email", ""),
                        new XElement("homepage", ""),
                        new XElement("url", "")),
                    new XElement("game",
                        new XAttribute("name", filenamewithoutext),
                        new XElement("description", filenamewithoutext),
                        new XElement("rom",
                            new XElement("name", filename),
                            new XElement("size", length),
                            // new XElement("crc", ""),
                            new XElement("md5", md5),
                            new XElement("sha1", sha1)))

                        );
            */

            }
        }

        public static string GetMD5HashFromFile(string fileName)
        {
           /* using (var stream = new BufferedStream(File.OpenRead(fileName), 100000))
            {
                return BitConverter.ToString(algorithm.ComputeHash(stream)).Replace("-", string.Empty);
            } */

            using (var md5 = MD5.Create())
            {
                using (var stream = File.OpenRead(fileName))
                {
                    return BitConverter.ToString(md5.ComputeHash(stream));
                }
            }

        }

        public static string GetSHA1HashFromFile(string fileName)
        {
            /* using (var stream = new BufferedStream(File.OpenRead(fileName), 100000))
             {
                 return BitConverter.ToString(algorithm.ComputeHash(stream)).Replace("-", string.Empty);
             } */

            using (var sha1 = SHA1.Create())
            {
                using (var stream = File.OpenRead(fileName))
                {
                    return BitConverter.ToString(sha1.ComputeHash(stream));
                }
            }
        }
    }
}